diff --git a/libgui/src/variable-editor.cc b/libgui/src/variable-editor.cc
--- a/libgui/src/variable-editor.cc
+++ b/libgui/src/variable-editor.cc
@@ -402,151 +968,118 @@ variable_editor::edit_variable (const QS
       notice_settings (settings);
     }
 
-  const int tab_count = m_tab_widget->count ();
-  for (int i = 0; i < tab_count; ++i)
+  QDockWidget *existing_qdw = m_main->findChild<QDockWidget *> (name);
+  if (existing_qdw != NULL)
     {
-      if (real_var_name (i) == name)
-        {
-          // Already open.
+      // Already open.
 
-          m_tab_widget->setCurrentIndex (i);
-          return;
-        }
+      // Put current focused variable out of focus
+      QFocusEvent event (QEvent::FocusOut, Qt::OtherFocusReason);
+      QApplication::sendEvent (m_main->focusWidget (), &event);
+
+      // Put existing variable in focus and raise
+      event = QFocusEvent (QEvent::FocusIn, Qt::OtherFocusReason);
+      QApplication::sendEvent (existing_qdw, &event);
+      existing_qdw->show ();
+      existing_qdw->raise ();
+      existing_qdw->setFocus ();
+
+      return;
     }
 
-  // Do not set parent.
+  variable_dock_widget *page = new variable_dock_widget (this);
+  page->setObjectName (name);
+  page->setAllowedAreas(Qt::LeftDockWidgetArea |
+                        Qt::RightDockWidgetArea);
+  m_main->addDockWidget (Qt::LeftDockWidgetArea, page);
 
-  QStackedWidget *widget_stack = new QStackedWidget ();
+  connect (QApplication::instance(), SIGNAL (focusChanged (QWidget *, QWidget *)),
+           page, SLOT (handle_focus_change (QWidget *, QWidget *)));
+  connect (page, SIGNAL (destroyed (QObject *)),
+           this, SLOT (variable_destroyed (QObject *)));
+  connect (page, SIGNAL (variable_focused_signal (const QString&)),
+           this, SLOT (variable_focused (const QString&)));
 
-  var_editor_tab *page = new var_editor_tab (widget_stack);
+  variable_editor_stack *stack = new variable_editor_stack (page);
+  stack->setObjectName (name);
+  page->setWidget (stack);
+  page->setFocusProxy (stack);
 
-  QVBoxLayout *vbox = new QVBoxLayout (page);
-  page->setLayout (vbox);
+  connect (stack, SIGNAL (command_signal (const QString&)),
+           this, SIGNAL (command_signal (const QString&)));
+  connect (stack, SIGNAL (edit_variable_signal (const QString&, const octave_value&)),
+           this, SLOT (edit_variable (const QString&, const octave_value&)));
+  connect (this, SIGNAL (level_up_signal ()),
+           stack, SLOT (levelUp ()));
+  connect (this, SIGNAL (save_signal ()),
+           stack, SLOT (save ()));
 
-  QLabel *label = new QLabel (page);
-  label->setTextFormat (Qt::PlainText);
-  vbox->addWidget (label, 0, Qt::AlignTop);
+  variable_editor_view *edit_view = stack->edit_view ();
 
-  variable_editor_model *model = new variable_editor_model (name, val);
+  edit_view->setObjectName (name);
+  edit_view->setFont (m_font);
+  edit_view->setStyleSheet (m_stylesheet);
+  edit_view->setAlternatingRowColors (m_alternate_rows);
+  edit_view->verticalHeader ()->setDefaultSectionSize (m_default_height
+                                                       + m_add_font_height);
 
-  QTableView *edit_view = make_edit_view (page, model);
+  connect (edit_view, SIGNAL (command_signal (const QString&)),
+           this, SIGNAL (command_signal (const QString&)));
+  connect (this, SIGNAL (delete_selected_signal ()),
+           edit_view, SLOT (delete_selected ()));
+  connect (this, SIGNAL (clear_content_signal ()),
+           edit_view, SLOT (clearContent ()));
+  connect (this, SIGNAL (copy_clipboard_signal ()),
+           edit_view, SLOT (copyClipboard ()));
+  connect (this, SIGNAL (paste_clipboard_signal ()),
+           edit_view, SLOT (pasteClipboard ()));
+  connect (this, SIGNAL (paste_table_clipboard_signal ()),
+           edit_view, SLOT (pasteTableClipboard ()));
+  connect (this, SIGNAL (selected_command_signal (const QString&)),
+           edit_view, SLOT (selected_command_requested (const QString&)));
+  connect (edit_view->horizontalHeader (),
+           SIGNAL (customContextMenuRequested (const QPoint&)),
+           edit_view, SLOT (createColumnMenu (const QPoint&)));
+  connect (edit_view->verticalHeader (),
+           SIGNAL (customContextMenuRequested (const QPoint&)),
+           edit_view, SLOT (createRowMenu (const QPoint&)));
+  connect (edit_view, SIGNAL (customContextMenuRequested (const QPoint&)),
+           edit_view, SLOT (createContextMenu (const QPoint&)));
+  connect (edit_view->horizontalScrollBar (), SIGNAL (actionTriggered (int)),
+           edit_view, SLOT (handle_horizontal_scroll_action (int)));
+  connect (edit_view->verticalScrollBar (), SIGNAL (actionTriggered (int)),
+           edit_view, SLOT (handle_vertical_scroll_action (int)));
 
-  QTextEdit *disp_view = make_disp_view (page, model);
+  variable_editor_model *model =
+    new variable_editor_model (name, val, stack);
 
-  page->set_model (model);
-
-  page->set_edit_view (edit_view);
-  page->set_disp_view (disp_view);
-
-  vbox->addWidget (widget_stack);
-
-  int tab_idx = m_tab_widget->addTab (page, name);
-
-  m_tab_widget->setCurrentIndex (tab_idx);
-
-  connect (model, SIGNAL (description_changed (const QString&)),
-           label, SLOT (setText (const QString&)));
-
+  connect (model, SIGNAL (edit_variable_signal (const QString&, const octave_value&)),
+           this, SLOT (edit_variable (const QString&, const octave_value&)));
   connect (model, SIGNAL (dataChanged (const QModelIndex&, const QModelIndex&)),
            this, SLOT (callUpdate (const QModelIndex&, const QModelIndex&)));
+  connect (this, SIGNAL (refresh_signal ()),
+           model, SLOT (update_data_cache ()));
+  connect (model, SIGNAL (set_editable_signal (bool)),
+           stack, SLOT (set_editable (bool)));
 
-  connect (this, SIGNAL (refresh_signal (void)),
-           model, SLOT (update_data_cache (void)));
+  edit_view->setModel (model);
+  connect (edit_view, SIGNAL (doubleClicked (const QModelIndex&)),
+           model, SLOT (double_click (const QModelIndex&)));
 
-  connect (model, SIGNAL (set_editable_signal (bool)),
-           page, SLOT (set_editable (bool)));
+  // Must supply a title for a QLabel to be created.  Calling set_title()
+  // more than once will add more QLabels.  Could change octave_dock_widget
+  // to always supply a QLabl (initially empty) and then simply update its
+  // contents.
+  page->set_title (name);
+  QLabel *existing_ql = page->titleBarWidget ()->findChild<QLabel *> ();
+  connect (model, SIGNAL (update_label_signal (const QString&)),
+           existing_ql, SLOT (setText (const QString&)));
 
-  enable_actions ();
-}
+  model->update_data (val);
 
-QTableView *
-variable_editor::make_edit_view (var_editor_tab *page,
-                                  variable_editor_model *model)
-{
-  QTableView *table = new QTableView (page);
-
-  model->setParent (table);
-
-  table->setModel (model);
-  table->setWordWrap (false);
-  table->setContextMenuPolicy (Qt::CustomContextMenu);
-  table->setSelectionMode (QAbstractItemView::ContiguousSelection);
-
-  table->horizontalHeader ()->setContextMenuPolicy (Qt::CustomContextMenu);
-  table->verticalHeader ()->setContextMenuPolicy (Qt::CustomContextMenu);
-
-  connect (table->horizontalHeader (),
-           SIGNAL (customContextMenuRequested (const QPoint&)),
-           this, SLOT (columnmenu_requested (const QPoint&)));
-
-  connect (table->verticalHeader (),
-           SIGNAL (customContextMenuRequested (const QPoint&)),
-           this, SLOT (rowmenu_requested (const QPoint&)));
-
-  connect (table, SIGNAL (customContextMenuRequested (const QPoint&)),
-           this, SLOT (contextmenu_requested (const QPoint&)));
-
-  connect (table, SIGNAL (doubleClicked (const QModelIndex&)),
-           this, SLOT (double_click (const QModelIndex&)));
-
-  table->setHorizontalScrollMode (QAbstractItemView::ScrollPerPixel);
-  table->setVerticalScrollMode (QAbstractItemView::ScrollPerPixel);
-
-  connect (table->horizontalScrollBar (), SIGNAL (actionTriggered (int)),
-           page, SLOT (handle_horizontal_scroll_action (int)));
-
-  connect (table->verticalScrollBar (), SIGNAL (actionTriggered (int)),
-           page, SLOT (handle_vertical_scroll_action (int)));
-
-  table->setFont (m_font);
-  table->setStyleSheet (m_stylesheet);
-  table->setAlternatingRowColors (m_alternate_rows);
-#if defined (HAVE_QT4)
-  table->verticalHeader ()->setResizeMode (QHeaderView::Interactive);
-#else
-  table->verticalHeader ()->setSectionResizeMode (QHeaderView::Interactive);
-#endif
-  table->verticalHeader ()->setDefaultSectionSize (m_default_height
-                                                   + m_add_font_height);
-
-  int col_width = model->column_width ();
-
-  if (col_width > 0)
-    {
-#if defined (HAVE_QT4)
-      table->horizontalHeader ()->setResizeMode (QHeaderView::Interactive);
-#else
-      table->horizontalHeader ()->setSectionResizeMode (QHeaderView::Interactive);
-#endif
-
-      // col_width is in characters.  The font should be a fixed-width
-      // font, so any character will do.  If not, you lose!
-
-      QFontMetrics fm (m_font);
-      int w = col_width * fm.width ('0');
-      table->horizontalHeader ()->setDefaultSectionSize (w);
-    }
-
-  return table;
-}
-
-QTextEdit *
-variable_editor::make_disp_view (var_editor_tab *page,
-                                 variable_editor_model *model)
-{
-  QTextEdit *viewer = new QTextEdit (page);
-
-  model->setParent (viewer);
-
-  QVariant v_data = model->data ();
-
-  QString str = v_data.toString ();
-
-  viewer->setLineWrapMode (QTextEdit::NoWrap);
-  viewer->setPlainText (str);
-  viewer->setReadOnly (true);
-
-  return viewer;
+  QList<QTableView *> viewlist = findChildren<QTableView *> ();
+  if (viewlist.size () == 1)
+    m_tool_bar->setEnabled (true);
 }
 
 void
@@ -555,27 +1088,6 @@ variable_editor::refresh (void)
   emit refresh_signal ();
 }
 
-bool
-variable_editor::has_focus (void)
-{
-  // FIXME: This only generates exceptions in certain circumstances.
-  // Get a definitive list and eliminate the need to handle exceptions?
-
-  if (m_tab_widget->currentIndex () == -1)
-    return false;  // No tabs.
-
-  try
-    {
-      return m_tab_widget->current_tab_has_focus ();
-    }
-  catch (...)
-    {
-      return false;
-    }
-
-  return false;
-}
-
 QList<QColor>
 variable_editor::default_colors (void)
 {
@@ -686,12 +1198,6 @@ variable_editor::notice_settings (const 
     icon_size = st->pixelMetric (QStyle::PM_SmallIconSize);
 
   m_tool_bar->setIconSize (QSize (icon_size, icon_size));
-
-  // Shortcuts.
-
-  shortcut_manager::set_shortcut (m_close_action, "editor_file:close");
-  shortcut_manager::set_shortcut (m_close_all_action, "editor_file:close_all");
-  shortcut_manager::set_shortcut (m_close_others_action, "editor_file:close_other");
 }
 
 void
